
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <pthread.h>

pthread_mutex_t mp;

void enter_CS(char *s) 
{
  pthread_mutex_lock(&mp);
  printf("%s: \tentering CS\n", s);
}

void exit_CS(char *s)
{
  printf("%s: \texiting CS\n", s);
  pthread_mutex_unlock(&mp);
}

void critical_work(int number) 
{
  sleep(1);
}

void non_critical_work(int number) 
{
  sleep(1);
}

void *thread_func(void *arg)
{
  int i;
  char *message;
  int number;
  
  number = (int) arg;
  
  message = (char *) malloc(1024);
  assert(message != NULL);
  
  for(i = 0; i < number; i++) {
    message[i] = '\t';
  }
  message[i] = ('0' + i);
  i++;
  message[i] = '\0';
  
  for(i = 0; i < 10; i++) {
    enter_CS(message); 
    critical_work(number); 
    exit_CS(message);
    non_critical_work(number);
  }

  return NULL;
}

#define DEBUG(s) {int i; i = (s); assert(i == 0);}

int main(void)
{ 
  void *status;
  pthread_t thread1_tid, thread2_tid;
  pthread_attr_t attributes;

  DEBUG(pthread_mutex_init(&mp, NULL));
  DEBUG(pthread_attr_init(&attributes));
  DEBUG(pthread_create(&thread1_tid, &attributes, 
		       &thread_func, (void *) 1));
  DEBUG(pthread_create(&thread2_tid, &attributes, 
		       &thread_func, (void *) 2));

  DEBUG(pthread_join(thread1_tid, &status));
  DEBUG(pthread_join(thread2_tid, &status));

  DEBUG(pthread_mutex_destroy(&mp));

  return 0;
}

