
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <assert.h>
#include <stdlib.h>
#include <values.h>

// #define N 1000*1000*100 
#define N 100

volatile int n = 0;
volatile int max = -2147483647;

void temporize() 
{
  fprintf(stderr, ".");
  if ((random() % 8) == 0) sleep(1);
}

void *thread_func(void *arg)
{
  int i;
  int tmp;
  int number  =  (int) arg;

  int incr = (number==0)?-1:1;
  
  for (i = 0; i < N; i++) {
      tmp = n;
      temporize();
      n = tmp + incr;
      if (n > max) max = n;
  }
  return NULL;
}

#define DEBUG(s) {int i; i = (s); assert(i == 0);}

int main(void)
{ 
  void *status;
  pthread_t thread1_tid, thread2_tid;
  pthread_attr_t attributes;

  printf("Begin: N = %d, n = %d, max = %d\n", 
	 N, n, max);

  DEBUG(pthread_attr_init(&attributes));
  DEBUG(pthread_create(&thread1_tid, &attributes, 
		       &thread_func, (void *) 0));
  DEBUG(pthread_create(&thread2_tid, &attributes, 
  	       &thread_func, (void *) 1));

  DEBUG(pthread_join(thread1_tid, &status));
  DEBUG(pthread_join(thread2_tid, &status));

  printf("End: N = %d, n = %d, max = %d\n", 
	 N, n, max);

  return 0;
}


